program Enregistrement;

{$mode objfpc}
{$modeswitch advancedrecords}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes,
  SysUtils
  { you can add units after this };

type

 { TPerson }

 TPerson = record
  strict private
    FFemale: Boolean;
    FName, FSurname : String;
  public
    constructor Create ( AObject : TObject );
    function IsValidPerson: Boolean;
    function IsValidName: Boolean;
    function IsValidSurName: Boolean;
    class operator +( APerson1, APerson2 : TPerson):TPerson;
    property Female : Boolean read FFemale write FFemale;
    property Name : String read FName write FName;
    property Surname : String read FSurname write FSurname;
  end;

{ TPerson }

constructor TPerson.Create ( AObject : TObject );
begin
  FFemale:=False;
end;

function TPerson.IsValidPerson: Boolean;
begin
  Result := IsValidSurName and IsValidName;
end;

function TPerson.IsValidName: Boolean;
begin
    Result := FName > '';

end;

function TPerson.IsValidSurName: Boolean;
begin
    Result := FSurname > '';
end;

class operator TPerson.+(APerson1, APerson2 : TPerson): TPerson;
begin
  Result.Name    := APerson1.Name   +APerson1.Name;
  Result.Surname := APerson1.Surname+APerson1.Surname;
end;


var fPerson : TPerson;
    FSaisie : String;
begin
  with fPerson do
   Begin
    WriteLn('Entre le prénom d''une personne.');
    readln(FSaisie);
    Name := FSaisie;
    WriteLn('Entre le nom d''une personne.');
    readln(FSaisie);
    Surname:=FSaisie;
    if IsValidPerson Then
     WriteLn('La personne ' + Name + ' ' + Surname +' est correctement remplie.')
    Else
     if IsValidName Then
       WriteLn('La personne ' + fPerson.Name + ' possède un nom valide.')
    Else
    if IsValidSurName Then
      WriteLn('La personne ' + fPerson.Name + ' possède un prénom valide.')
     Else
      WriteLn('La personne est à renseigner.');

   end;
end.

